#pragma once

#include "ecs.hpp"

//////////////////////////////////////////////////////////////////////////////////////////////
// ECS type-safe modules redefinition 
/////////////////////////////////////////////////////////////////////////////////////////////
#define ECS_IMPORT_COMPONENT ecs_define_component
#define ECS_IMPORT_ENTITY ecs_define_tag

ecs_define_module(FlecsComponentsTransform)
ecs_define_module(FlecsComponentsGeometry)
ecs_define_module(FlecsComponentsGraphics)
ecs_define_module(FlecsComponentsInput)
ecs_define_module(FlecsSystemsTransform)

#undef ECS_IMPORT_COMPONENT
#undef ECS_IMPORT_ENTITY

//////////////////////////////////////////////////////////////////////////////////////////////
// ECS type-unsafe modules redefinition 
/////////////////////////////////////////////////////////////////////////////////////////////
#define ECS_IMPORT_COMPONENT ecs_define_nothing
#define ECS_IMPORT_ENTITY ecs_define_tag

ecs_define_module(FlecsComponentsMeta)

#undef ECS_IMPORT_COMPONENT
#undef ECS_IMPORT_ENTITY

void ecs_cry_modules_integrate(ecs* self, int flags);

//////////////////////////////////////////////////////////////////////////////////////////////
// ECS misc
//////////////////////////////////////////////////////////////////////////////////////////////

extern EcsColor ecs_color_WHITE;

void ecs_mat3x3_set_identity(EcsMat3x3 *matrix);
